//package newpackage;

import java.awt.Color;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.util.Date;
import javax.swing.JFrame;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;

/**
 * Clase NewFrame crea los elementos del Frame. 
 * @author Olga Godoy
 * @author Alejandro Homes
 */
public class NewFrame extends JFrame {
    //Elementos del Menu
    JMenuBar MBarra=new JMenuBar();
    JMenu MArchivo=new JMenu("Archivo");
    JMenuItem MAbrir=new JMenuItem("Abrir");
    JMenuItem MTerminar=new JMenuItem("Terminar"); 
    JMenu MAccion=new JMenu("Accion");
    JMenuItem MRodar=new JMenuItem("Rodar");
    JMenuItem MBuscar=new JMenuItem("Buscar");
    JMenu MAbout=new JMenu("About");
    //Elementos del frame
    JFrame frame = new JFrame("Tombola en Java"); 
    JTextArea jTextArea1 = new JTextArea();
    ColorPane jTextPane2 = new ColorPane();
    JScrollPane jScrollPane1 = new JScrollPane();
    JScrollPane jScrollPane2 = new JScrollPane();
    JPanel ventana = new JPanel(new GridLayout(1,2,5,1));
    
    InsertionSorter IS = new InsertionSorter();

    private String ruta;
    private AbrirArchivo abrir;
    private Estudiante[] Estud;

    /**
     * Constructor
     */
    public NewFrame() {
          
        //Menu
        MArchivo.add(MAbrir);
        MArchivo.add(MTerminar);
        MAccion.add(MRodar);
        MAccion.add(MBuscar);

        MBarra.add(MArchivo);
        MBarra.add(MAccion);
        
        MBarra.add(MAbout);

        setJMenuBar(MBarra);
        frame.setJMenuBar(MBarra);
        
        MAbrir.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                MAbrirActionPerformed(evt);
            }
        });
        
        MTerminar.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                MTerminarActionPerformed(evt);
            }
        });
        
        MRodar.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                MRodarActionPerformed(evt);
            }
        });
        
        MBuscar.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                MBuscarActionPerformed(evt);
            }
        });
        
        MAbout.addMouseListener(new MouseAdapter() {
            public void mousePressed(MouseEvent evt) {
                MAboutMousePressed(evt);
            }
        });
        
        //Text
        jTextArea1.setEditable(false);
        jTextPane2.setEditable(false);
        
        jScrollPane1.setViewportView(jTextArea1);
        jScrollPane2.setViewportView(jTextPane2);
        
        ventana.add(jScrollPane1);
        ventana.add(jScrollPane2);
        
        frame.add(ventana);
        
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        frame.pack();
        frame.setSize(700,400);
        frame.setVisible(true); 
    }

    /**
     * Action Lisener se crea un filechooser para abrir un archivo de texto
     * @param evt evento, click del mouse
     */
    private void MAbrirActionPerformed(ActionEvent evt) {
        FileChooser abrirarch = new FileChooser();
        ruta = abrirarch.getRute();
       
        abrir = new AbrirArchivo(ruta);
        Estud = abrir.llenarArregloEstud();
       
        jTextArea1.setText("");
        for(int k =0 ; k<Estud.length;k++)
            jTextArea1.append(Estud[k].getName()+"\n"); 
    }
    
    /**
     * Action Lisener, da termino a la aplicacion
     * @param evt evento, click del mouse
     */
    private void MTerminarActionPerformed(ActionEvent evt) {
        System.exit(0);
    }
   
    /**
     * Action Lisener ejecuta el arloritmo para buscar string
     * @param evt evento, click del mouse
     */
    private void MBuscarActionPerformed(ActionEvent evt) {
        LinearSearcher busca = new LinearSearcher();
        JFrame ventana = new JFrame();
        String message = "Alumno:";
        String titulo = "Buscar Alumno";
        int icono = 3;
        String buscar = JOptionPane.showInputDialog(ventana,message,titulo,icono);
        
        int[] indices = busca.buscar(Estud,buscar);
  
        Color color = Color.WHITE;
       
        jTextPane2.setEditable(true);
        jTextPane2.setText("");
        
        for(int x=0; x<Estud.length; x++){
            for(int z = 0; z < indices.length-1 ; z++){
                if(indices[z] == Estud[x].getindice()){
                    color = Color.BLUE;
                    break;
                }
                else{        
                    color = Color.WHITE;
                }
            }
            jTextPane2.append(color, x+1 + "  " + Estud[x].getName() + "\n");
        }
        jTextPane2.setEditable(false);
    }
     
    /**
     * Action Lisener  ejecuta la tombola
     * @param evt evento, click del mouse
     */
    private void MRodarActionPerformed(ActionEvent evt) {
        abrir.Randomm(Estud);
        IS.ordenar(Estud);
        jTextPane2.setEditable(true);
        jTextPane2.setText("");
        
        for(int w=0; w< Estud.length ; w++){
            jTextPane2.append(Color.WHITE , w+1 + "  " + Estud[w].getName() + "\n");
        }
        jTextPane2.setEditable(false);
    }
    
    /**
     * Action Lisener depliega el cuadro About
     * @param evt evento, click del mouse
     */
    private void MAboutMousePressed(MouseEvent evt) {
        Date fecha = new Date();
        JFrame ventana = new JFrame();
        String message = "\nDisenio y Programacion Orientados a Objetos\n\nAuthors:  Olga Godoy\n" +
                "                 Alejandro Homes\n\nProfesor: Agustin Gonzalez\n\nDate:       "+fecha.toString();
        String titulo = "About";
        int icono = 1;
        JOptionPane.showMessageDialog(ventana,message,titulo,icono);
    }
}
